//****************************************************************
//	地底最大の作戦
//	Oh!X 1988/9号よりの移植
//****************************************************************
// BGを使わずグラフィックで描いた版
// やはりiPad1/2では重い。というかBG版より更に遅い。
// for V3.2 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

// 定数定義 / Define constant
enum
	LEFT_TIME=500://2000:// 残り時間
	//
	// 画面幅など
	WX=48		:// 768/16
	WY=31
	OFST_Y=6	:// selectMenu()が基地に被らないような座標にする
	MES_Y=16	:// center()の表示座標
	// 仮想VRAM内座標
	KITIY=27	:// 基地のy座標
	SNAKEY=4	:// 新しいヘビを発生させるy座標
	// 個数
	MAX_ESA=2	:// 餌	餌は2個で固定記述されている部分もあるので注意
	MAX_SNAKE=10:// へび
	//
	// スプライトプレーンコード
	// MAX_*を変更したときはここも変更すること
	// パターンコード透過コードと重ならないように設定すること
	PLANE_MAN	=0  :// 人のプレーンは１つでこれにMOJI_?MANが割り当てられる
	PLANE_ESA		:// 〜+MAX_ESA-1	=1,2
	PLANE_SNAKE =PLANE_ESA+MAX_ESA:// 〜+MAX_SNAKE=3〜12 ; MOJI_SNAKEまたはMOJI_AT
	// 以下BGのみ
	// パターンコード＝プレーンコード
	MOJI_SPACE =' ':// chr$(32)
	MOJI_SPACE2=',':// 仮想VRAM上にスペースを入れるが、表示は何もしない
	MOJI_PLUS  ='+':// ＋
	MOJI_AT	   ='@':// ＠ 丸まったヘビ
	MOJI_DTRI  ='Y':// ▽
	MOJI_UTRI  ='W':// △
	MOJI_LEFT  ='`':// ＼
	MOJI_RIGHT ='/':// ／
	MOJI_CIRCLE='*':// ◎
	// 以下は特殊パターンになる
	MOJI_KABE1 ='$':// ＃
	MOJI_KABE2 ='0':// ◆
	MOJI_KABE3 ='o':// ◇
	MOJI_TUTI  ='#':// 土
	MOJI_UMAN  ='A':// 上向き人
	MOJI_LMAN  ='<':// 左向き人
	MOJI_RMAN  ='>':// 右向き人
	MOJI_DMAN  ='V':// 下向き人
	MOJI_SNAKE ='%':// 動くヘビ
	MOJI_SNAKE_BG='a':// ヘビBG表示用
	MOJI_ESA   ='.':// 餌
	MOJI_ENTER ='_':// 基地入口
	MOJI_UKITI ='=':// 基地上
	MOJI_LKITI =']':// 基地左
	MOJI_RKITI ='[':// 基地右
	MOJI_DKITI ='~':// 基地下
	// initDisp()/death()の中に各文字を用いた文字列記述があるので、ここを変更したときはそちらも変更すること
	// キー / Key code
	EXITKEY	='!':// 強制終了
	KLEFT	='4'
	KRIGHT	='6'
	KUP		='8'
	KDOWN	='2'
	KLD		='1'
	KRD		='3'
	KLU		='7'
	KRU		='9'
	KLESA	='z'
	KRESA	='x'
endenum

enum
	XC=3
	YC=3
	K1X=16*4
	K1Y=16*4
endenum
dim int keys( XC*YC-1)={0,KUP,0,KLEFT,FKEY_WAKUONLY,KRIGHT,KLESA+FKEY_NOT_REPEAT,KDOWN,KRESA+FKEY_NOT_REPEAT}

str RECHIGH="SNAKE.HSC":// ハイスコア ファイル名 / Hi-score file name

//****************************************************************
// グローバル変数 / Grobal variable

int manx,many			:// 人の座標
int skazu				:// へびの数
int timer,sco,hsc,hpoint:// 時間と得点
int warn,stimes			:// 警告フラグと丸まっている時間
int x0:// リターン値用

dim int ex(MAX_ESA),ey(MAX_ESA),esa(MAX_ESA)		:// 餌の座標と表示フラグ
dim int sx(MAX_SNAKE),sy(MAX_SNAKE),stime(MAX_SNAKE):// へび座標と丸まっているカウント

// 今回はタッチエリアが2箇所存在する
dim int	touchNo1(10)	:// タッチエリア番号 / touch area number
int touchallcnt1		:// タッチエリア数   / the number of touch area
dim int	touchNo2(10)	:// タッチエリア番号 / touch area number
int touchallcnt2		:// タッチエリア数   / the number of touch area

// 仮想VRAM / virtual VRAM
dim char tvram(WX,WY)

//****************************************************************
// 画面系初期設定 / Screen initialize

font("Migu-1M-Regular",16)
int fzenhan
width(WX,,fzenhan,NO)
int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2
vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_SPAGE+B_GPAGE0+B_GPAGE1):// GPAGE1はキー表示
apage(GPAGE0):bitmapOpen(0,0,YES):bitmapWipe()
tborder(1,CTHCYAN)
sp_disableBG0SPBG1(YES)
beep2(13,YES)
setTouchArea(0,0,0,0,0,YES):// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate

//****************************************************************
// パターンの定義
// 元はフォントパターンなので、このデータ形式である
// スプライトパターンエリアをパターンの記憶領域としても使う

sp_init():// ここでスプライト画面は非表示になる / Hide sprite screen
sp_color(0,&h00000000):// 透明 / Transparency
sp_color(1,&hffffffff)
setSprite("00,00,00,00,01,00,01,00,01,00,01,00,01,00,3f,fc,01,00,01,00,01,00,01,00,01,00,01,00,00,00,00,00",MOJI_PLUS	)
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",MOJI_SPACE	)
setSprite("00,00,00,00,03,c0,0c,30,10,08,11,a8,22,64,24,44,24,44,24,c8,13,70,10,04,0c,18,03,e0,00,00,00,00",MOJI_AT		)
setSprite("00,00,00,00,7f,fe,20,04,20,08,10,08,10,10,08,10,08,20,04,40,04,40,02,80,02,80,01,00,00,00,00,00",MOJI_DTRI	)
setSprite("00,00,00,00,01,00,02,80,02,80,04,40,04,40,08,20,08,10,10,10,10,08,20,08,20,04,7f,fe,00,00,00,00",MOJI_UTRI	)
setSprite("80,00,40,00,20,00,10,00,08,00,04,00,02,00,01,00,00,80,00,40,00,20,00,10,00,08,00,04,00,02,00,01",MOJI_LEFT	)
setSprite("00,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,00",MOJI_RIGHT	)
setSprite("00,00,03,c0,0c,30,10,08,23,c4,24,24,48,12,48,12,48,12,48,12,24,24,23,c4,10,08,0c,30,03,c0,00,00",MOJI_CIRCLE	)
setSprite("02,10,02,10,02,10,02,10,1f,fc,1f,fc,04,20,04,20,04,20,04,20,3f,f8,3f,f8,08,40,08,40,08,40,08,40",MOJI_KABE1	)
setSprite("01,80,03,c0,07,e0,0f,f0,1f,f8,3f,fc,7f,fe,ff,ff,ff,ff,7f,fe,3f,fc,1f,f8,0f,f0,07,e0,03,c0,01,80",MOJI_KABE2	)
setSprite("01,80,02,40,04,20,08,10,10,08,20,04,40,02,80,01,80,01,40,02,20,04,10,08,08,10,04,20,02,40,01,80",MOJI_KABE3	)
setSprite("80,01,40,02,20,04,10,08,08,10,04,20,02,40,01,80,01,80,02,40,04,20,08,10,10,08,20,04,40,02,80,01",MOJI_TUTI	)
setSprite("00,00,07,e0,07,e0,07,e0,07,e0,01,80,01,80,3f,fc,01,80,01,80,03,c0,06,60,0c,30,18,18,30,0c,00,00",MOJI_UMAN	)
setSprite("00,00,00,00,01,02,01,06,01,0c,79,18,79,30,7f,e0,7f,e0,79,30,79,18,01,0c,01,06,01,02,00,00,00,00",MOJI_LMAN	)
setSprite("00,00,00,00,40,80,60,80,30,80,18,9e,0c,9e,07,fe,07,fe,0c,9e,18,9e,30,80,60,80,40,80,00,00,00,00",MOJI_LMAN	)
setSprite("00,00,30,0c,18,18,0c,30,06,60,03,c0,01,80,01,80,3f,fc,01,80,01,80,07,e0,07,e0,07,e0,07,e0,00,00",MOJI_RMAN	)
setSprite("00,00,78,00,78,00,79,e0,1b,f0,1b,30,1b,30,1b,30,1b,30,1b,30,1b,36,1b,36,1b,36,1f,3e,0e,1c,00,00",MOJI_SNAKE	)
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,c0,03,20,03,a0,01,c0",MOJI_ESA	)
setSprite("ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff",MOJI_ENTER	)
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff",MOJI_UKITI	)
setSprite("80,00,c0,00,e0,00,f0,00,f8,00,fc,00,fe,00,ff,00,ff,80,ff,c0,ff,e0,ff,f0,ff,f8,ff,fc,ff,fe,ff,ff",MOJI_LKITI	)
setSprite("00,01,00,03,00,07,00,0f,00,1f,00,3f,00,7f,00,ff,01,ff,03,ff,07,ff,0f,ff,1f,ff,3f,ff,7f,ff,ff,ff",MOJI_RKITI	)
setSprite("ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",MOJI_DKITI	)

//****************************************************************
// main

int ret
int fp
int ky
dim int sc(0)

	hsc=0:// ハイスコアクリア
	fp=fopen(RECHIGH,"r")
	if (not fopenError(fp)) then {:// hi-score write
		fread(sc,1,fp)
		hsc=sc(0)
		fclose(fp)
	}
	
	str exit$
	if isLocalizeJapan() then {
		exit$="終了"
	} else {
		exit$="end"
	}
	setFunctionKey(0,exit$,EXITKEY)
	kBackgroundAlpha(0.7)
	displayFunctionKey(YES,0,0)
	sp_disp(YES)

	repeat
		// 初期化
		init()
		// タイトル表示
		cls()
		title()
		printKeys()
		initDisp()

		for ret=0 to rand2(15)+10-1:// 少しの間へびを動かす
			snake()
			vwait(7)
			ky=inkey()
			if ky=EXITKEY then break
		next
		if ky=EXITKEY then break

		message(localizedString("健闘を祈る！！","Good fight!!"),4)
		// 縦穴を貫通させる
		printxy(3   ,5,MOJI_SPACE,0)
		printxy(WX-4,5,MOJI_SPACE,0)
		//
		// ゲーム本体
		repeat
			ky=man()
			echeck()
			ret=snake()
			inc_snake()
			time_print()
			kbclr()
			vwait(5)
		until ret<>0 or ky=EXITKEY
		
		// ゲーム終了
		removeKeys()
		if ret=1 then death() else invade()
		message(localizedString("☆☆　ＧＡＭＥ　ＯＶＥＲ　☆☆","** Game Over **"),4)
		if sco>hsc then {
			center(3,localizedString("＊＊　新記録！！　＊＊","** New record!! **"),NO)
			hsc=sco
			hi_score()
			beep()
		}

		dim str menues(1)
		str title$
		if isLocalizeJapan() then {
			title$="もう一度しますか？"
			menues={"はい","いいえ"}
		} else {
			title$="Try again ?"
			menues={"Yes","No"}
		}
		switch selectMenu2(title$,menues)
			case 0
				ky=0
				// 次回実行のための準備
				// 丸まった蛇が残ることがあるので、消してしまう
				int i
				for i=0 to skazu-1
					sp_move(PLANE_SNAKE+i,-16,-16,MOJI_SPACE)
				next
				break
			case 1
				ky=EXITKEY
				break
		endswitch
	until ky=EXITKEY
	//
	displayFunctionKey(NO,0,0)
	
	// ハイスコアをファイルを書き出す
	fp=fopen(RECHIGH,"w")
	if (not fopenError(fp)) then {:// hi-score write
		sc(0)=hsc
		fwrite(sc,1,fp)
		fclose(fp)
	}

	bitmapClose()
	apage(GPAGE0)
end

//****************************************************************
// 関数
//****************************************************************

// スプライト定義
func setSprite(sptrn;str,no;int)
	// (0)16進文字列→配列
	dim char fnt(16/8*16)
	hexstrToArray(sptrn,fnt)

	// (1)フォントパターンをiOS型スプライトパターンに変換
	//locate(0,1)
	dim int ptrn(16*16)
	int i,j
	int fk=0,sk=0,col
	for i=1 to 16/8*16
		char c=fnt(fk):fk=fk+1
	//	print right$("0"+hex$(c),2);",";
		for j=0 to 7
			col=0
			if (c and bit(7-j))<>0 then col=&hffffffff:// とりあえず今は単色展開のみ
			ptrn(sk)=col
			sk=sk+1
		next
	next
//	print
	// (2)スプライトに定義
	sp_def(no,ptrn)

	// (3)仮表示 for test
//	int x=no mod 32
//	int y=no/32
//	bitmapPattern(x*16,y*16+128,16,16,ptrn)
//	sp_move(no,x*16,y*16+128,no)
endfunc

//****************************************************************

func score(point;int)
// 得点加算＆表示 / print score and add score
	sco=sco+point
	locate(0,1):prints("SCORE:")
	print_score(sco)
endfunc

//****************************************************************

func hi_score()
// ハイスコア表示 / print hi-score
	locate(15,1)
	prints("HI-SCORE:")
	print_score(hsc)
endfunc

//****************************************************************

func print_score(sco;int)
// 得点表示 / print score
	print using "#####0",sco
endfunc

//****************************************************************

func time_print()
// 時間表示 / print time
	locate(33,1)
	print using "TIME:###";timer/10
endfunc

//****************************************************************

func title()
// タイトル表示 / print title
	locate(0,0):prints(localizedString("＊＊　地底最大の作戦　＊＊","** The underground maximum strategy **"))
	score(0)
	hi_score()
	time_print()
endfunc

//****************************************************************

func center(y;int,mes;str,fbold;int)
// センタリング表示 / print message with centering
int x,wd=1
	// 日本語版は全角のみ、英語版は半角のみにすること
	// English is half width only and Japanese is double width only
	if isLocalizeJapan() then {
		wd=2:// 1文字の幅は2(全角)
	}
	x=(WX-utf8Len(mes)*wd)/2:// センタリング / centering
	if fbold then tAtrb(ATRB_BOLD):tColor(CTHRED)
	locate(x,y):print mes
	tAtrb(ATRB_NORMAL):tColor(CTHWHITE)
endfunc

//****************************************************************

func message(mes;str,tim;int)
// メッセージを指定回数点滅表示する / print message with blink specified times
int i,x,wd=1
	// 日本語版は全角のみ、英語版は半角のみにすること
	// English is half width only and Japanese is double width only
	if isLocalizeJapan() then {
		wd=2:// 1文字の幅は2(全角)
	}
	x=(WX-utf8Len(mes)*wd)/2:// センタリング / centering
	for i=0 to tim-1
		locate(x,3):print mes
		vwait(20)
		locate(x,3):print chr$(DISP_CTRL_CLEARLINE)
		beep()
		vwait(20)
	next
endfunc

//****************************************************************
// 仮想VRAM / Virtual VRAM
//****************************************************************
// 今回は各パターンが重なることはない

func printxy(x;int,y;int,c;char,no;int)
int plane
	if c=MOJI_SPACE2 then {
		// 仮想VRAM上のクリアのみ
		tvram(x,y)=MOJI_SPACE
		return
	}
	// 仮想VRAMに書き込む
	tvram(x,y)=c

	// 人と蛇と餌はスプライト、他は全てグラフィックである

	switch c
		case MOJI_UMAN
		case MOJI_LMAN
		case MOJI_RMAN
		case MOJI_DMAN
			// 人は同じプレーンでSPに表示
			plane=PLANE_MAN
			break
		case MOJI_ESA
			plane=PLANE_ESA+no
			break
		case MOJI_SNAKE
		case MOJI_AT	:// @はヘビと同じ座標で文字だけ変わる
			plane=PLANE_SNAKE+no
			break
		//
		case MOJI_SNAKE_BG
//			plane=MOJI_SNAKE_BG
			c=MOJI_SNAKE
		default
			// graphicに表示する
			// スプライトとして定義しているパターンを読み出してグラフィックに描画する
			dim int ptrn(16*16)
			sp_pat(c,ptrn):// パターン読みだし
			bitmapPattern(x*16,(y+OFST_Y)*16,16,16,ptrn)
			bitmapImgLoad():// 表示更新
			//bg_put(BGpg,x,y+OFST_Y,c)
			return
	endswitch
	sp_move(plane,x*16,(y+OFST_Y)*16,c)
endfunc

//****************************************************************

func printxys(x;int,y;int,s;str)
int i
// sp_halt()は外部で制御すること
//	sp_halt(YES):// しばらくスプライトの表示を中止 / Pause sprite display
	for i=0 to strlen(s)-1
		printxy(x,y,s[i],0)
		x=x+1
		if x>=WX then x=0:y=y+1
		if y>=WY then y=WY-1
	next
//	sp_halt(NO):// スプライトの表示を再開 / Resume sprite display
endfunc

//****************************************************************

func int scrn(x;int,y;int)
// 仮想テキストＶＲＡＭを読み出す / Read virtual VRAM
	return(tvram(x,y))
endfunc

//****************************************************************

func init_tvram()
// 仮想テキストＶＲＡＭ初期化 / Initialize virtual VRAM
int x,y
	for x=0 to WX-1
		for y=0 to WY-1
			printxy(x,y,MOJI_SPACE,0)
		next
	next
endfunc

//****************************************************************
// キー入力
//****************************************************************

func printKeys()
	// 表示中央の座標
	// このゲームでは画面を注視する必要があるため、ど真ん中に重ねて表示する

	// 第1タッチキーエリア / First touch key area
	// 表示なしなのでdispsとfntは省略
	touchallcnt1=setTouchKeys(16*16+8,17*16,XC,YC,K1X,K1Y,keys,,,touchNo1)
	//
	// 第2タッチキーエリア / Second touch key area
	apage(GPAGE1)
	dim str disps(XC*YC-1)={" ","↑"," ","←"," ","→","。","↓","。"}
	touchallcnt2=setTouchKeys(16*16+8,41*16,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo2)
	apage(GPAGE0)
endfunc

func removeKeys()
// 全タッチアリアの解除 / reset all key touch area
	// テキスト文字表示エリアを確保するためキーを消す
	// 第1タッチキーは表示なしなのでresetTouchKeys()を使ってはダメ
	resetAllTouchKeys(touchNo1,touchallcnt1)
	apage(GPAGE1)
	resetTouchKeys(16*16+8,41*16,XC,YC,K1X,K1Y,keys,touchNo2)
	apage(GPAGE0)
endfunc

//****************************************************************
// サブルーチン / Subroutines
//****************************************************************

func init()
// 初期化 / Initialize
	int i
	// 乱数初期化 / randomize init.
	srand2()
	// 時間＆得点 / time and score
	timer=LEFT_TIME
	sco=0
	hpoint=1:// へび１匹の得点 / score at each snake
	// 人間 / human
	manx=WX/2-2
	many=KITIY
	for i=0 to MAX_ESA-1
		esa(i)=0
	next
	// へび関係 / about snake
	skazu=6	:// 初期のヘビの数 / initial the number of snake
	for i=0 to MAX_SNAKE-1
		stime(i)=0
	next
	warn=0
	stimes=80:// 丸まっている時間 / time of 
endfunc

//****************************************************************

func initDisp()
// 画面初期化 / screen initialize
int x,y
	sp_halt(YES)

	// 仮想テキストＶＲＡＭクリア
	init_tvram()

	// 初期画面
	// 土
	for y=SNAKEY+1 to KITIY+2
		for x=0 to WX-1
			printxy(x,y,MOJI_TUTI,0)
		next
	next
	
	// ヘビが横から回り込まないように左右端に土を配置
	printxy(0	,SNAKEY,MOJI_TUTI,0)
	printxy(WX-1,SNAKEY,MOJI_TUTI,0)
	
	// 基地
	for x=0 to WX-1
		printxy(x,KITIY-1,MOJI_UKITI,0)
		printxy(x,KITIY  ,MOJI_PLUS ,0)
		printxy(x,KITIY+1,MOJI_DKITI,0)
	next
	// 基地の真ん中
	printxys(WX/2-3,KITIY-1,"_ _")
	printxys(WX/2-9,KITIY  ,"0o$oo0] [0oo$o0")
	
	// 最初から掘られている穴
	// 縦穴：ただし貫通はさせない
	for y=6 to 16-1
		printxy(3   ,y,MOJI_SPACE,0)
		printxy(WX-4,y,MOJI_SPACE,0)
	next
	// 横穴
	for x=1 to WX-1-1
		printxy(x,16,MOJI_SPACE,0)
	next

	// 中心口
	for y=17 to KITIY
		printxy(WX/2-2,y,MOJI_SPACE,0)
	next

	// 常時動くもの；人とヘビはスプライトで表示
	// 人の表示
	printxy(manx,many,MOJI_UMAN,0)

	// へびの配置
	for x=0 to skazu-1
		newsnake(x)
	next
	//
	sp_halt(NO)
endfunc

//****************************************************************

func int man()
// 人の動作 / Move the man
int x,y,ch
	// キー入力 → 移動、餌処理
	ch=inkey()
	if ch=EXITKEY then return(ch):// 終了キー
	
	// 座標待避
	x=manx:y=many
	
	switch ch
		// 移動
// 斜めは封印
//		case KLU:x=x-1:y=y-1:break
//		case KRU:x=x+1:y=y-1:break
//		case KLD:x=x-1:y=y+1:break
//		case KRD:x=x+1:y=y+1:break
		//
		case KDOWN :y=y+1:break
		case KUP   :y=y-1:break
		case KLEFT :x=x-1:break
		case KRIGHT:x=x+1:break
		// 餌
		case KLESA:
			x=x-1-1:// 次の行で+1されるので、その分さらに引いておく
		case KRESA:
			x=x+1
			if esa(0)=0 or esa(1)=0 then {:// 餌は２つまでなので(どちらかが未使用なら置ける)
				// 置こうとした所が空間だった時だけ置ける
				if scrn(x,many)=MOJI_SPACE then eput(x,many)
			}
			// 餌を置いた時は動かない
			return
	endswitch
	
	if x=manx and y=many then return:// 動いていない
	
	// 座標修正
	if y>=KITIY-1 and x<>manx then return:// 基地の中では上下にしか動けない
	if x>=WX 	  then x=0   :y=y+1
	if x<0   	  then x=WX-1:y=y-1
	if y<SNAKEY-1 then y=SNAKEY-1	:// 人の動ける一番上
	if y>=KITIY   then y=KITIY		:// 人の動ける一番下（基地の１つ上）

	// 人の移動元を消す；仮想VRAMのみ
	printxy(manx,many,MOJI_SPACE2,0)

	// 移動先判定
	switch scrn(x,y)
		case MOJI_UKITI
			// 移動しようとするところが基地の天井だったら移動できない
			break
		default
			manx=x
			many=y
			break
	endswitch
	printxy(manx,many,MOJI_SPACE,0):// 壁を消す必要がある
	esaman(manx,many):// 餌拾い処理
	printxy(manx,many,MOJI_UMAN ,0):// 人の表示
	// 外に出すキーはなし
	return(0)
endfunc

//****************************************************************

func esaman(x;int,y;int)
// 人/ヘビが餌を拾う/食べる
int i
	for i=0 to MAX_ESA-1
		if ex(i)=x and ey(i)=y then {
			esa(i)=0
			 ex(i)=0
			 ey(i)=0
			sp_move(PLANE_ESA+i,-16,-16):// 餌のスプライトを消す （表示外領域へ移動）
			beep()
		}
	next
endfunc

//****************************************************************

func eput(x;int,y;int)
// 餌表示 / Display the food
int e=0
	// ここにくる時は餌が置ける状態、即ちesa(0)またはesa(1)が０である
	if esa(1)=0 then e=1
	esa(e)=1
	printxy(x,y,MOJI_ESA,e)
	y=efall(x,y,e)
	ex(e)=x
	ey(e)=y
	beep()
endfunc

//****************************************************************

func int efall(x;int,y;int,eno;int)
// 餌落下 / Fall the food
int sc
	repeat
		sc=scrn(x,y+1):// 下は...
		if sc=MOJI_SPACE then {:// 下が空間の時は落下する
			printxy(x,y,MOJI_SPACE2,0):// 仮想VRAMの更新
			vwait(3)
			y=y+1
			printxy(x,y,MOJI_ESA,eno)
		}
	until sc<>MOJI_SPACE:// 下が空間の間落下し続ける
	return(y)
endfunc

//****************************************************************

func echeck()
// 餌落下処理：人が下に空間を作った時のため
int i
	for i=0 to MAX_ESA-1
		if esa(i)<>0 then ey(i)=efall(ex(i),ey(i),i)
	next
endfunc

//****************************************************************

func int snake()
// へび移動 / Move the snake
int sn,ret=0
	for sn=0 to skazu-1
		if ret<>0 then break
		if stime(sn)>0 then {:// 丸まっている
			ret=scount(sn)
		} else {:// 移動出来る
			ret=smove(sn)
		}
	next
	return(ret):// プレイ続行 / Continue playing
endfunc

//****************************************************************

func int scount(sn;int)
// 丸まっている間のへび処理
int x,y,ret=0
	x=sx(sn)
	y=sy(sn)
	
	// 丸まりカウントを減らす
	stime(sn)=stime(sn)-1

	if x=manx and y=many then {:// 丸まっている時に人間に捕獲された
		newsnake(sn):// 新しいへびを出す
		score(hpoint):// 得点表示
		beep()
	} else {:// 丸まっている
		printxy(x,y,MOJI_AT,sn)
		// 下が空間の時は落下する
		// これは丸まっているへびの下を人間が掘り、更に移動して下に空間が出来た時に起こる
		if scrn(x,y+1)=MOJI_SPACE then ret=down(sn,x,y)
	}
	return(ret)
endfunc

//****************************************************************

func int smove(sn;int)
// へび移動 / Move snake
// リターン値 : 0=移動した , 1=人間が食べられた , 2=基地が占領された
int x
int y,ch,ret=0
	x=sx(sn)
	y=sy(sn)
	// 人がへびに当たった
	if x=manx and y=many then return(1)
	
	// 下が空間なら落下
	if scrn(x,y+1)=MOJI_SPACE then {
		ret=down(sn,x,y)
	} else {:// 左右移動
		printxy(x,y,MOJI_SPACE2,0):// 仮想VRAMを消す
		if rand2(8)<4 then x=x+1 else x=x-1:// 左右移動
		// 座標修正
		y=snakeMoveCheck(x,y)
		x=x0
		
		// 移動先判定と表示
		if x=manx and y=many then return(1):// 移動先は人だった
		
		ch=scrn(x,y)
		if ch=MOJI_ESA then {:// 移動先は餌の時
			// 先に餌を消す
			esaman(x,y)
			// しばらく眠る
			printxy(x,y,MOJI_AT,sn)
			// sleep count
			stime(sn)=stimes
			// 餌フラグクリア
			if x=ex(0) and y=ey(0) then esa(0)=0 else esa(1)=0
		} else {
			if ch<>MOJI_SPACE then {:// 移動先が空間、餌でない時
				// 沈み込むかその場に留まるか
				x=sx(sn):y=sy(sn)
				if warn then {:// すでに警告が出ている
					// 行き場のないへびは沈み込む
					// 両側がふさがっている時は沈み込む
					if wall(x+1,y) and wall(x-1,y) then {
						y=y+1
						printxy(x,y,MOJI_SPACE,0):// 壁を消す必要がある
					}
				}
				if y=KITIY then ret=2:// 基地内に侵入した
			}
			printxy(x,y,MOJI_SNAKE,sn)
		}
		sx(sn)=x:sy(sn)=y
	}
	return(ret)
endfunc

//****************************************************************

func int down(sn;int,x;int,y;int)
// へびの落下 / Fall the snake
int ch,y1
	repeat
		y1=y+1
		ch=scrn(x,y1):// 落下先は...
		if ch=MOJI_SPACE then {:// 空間
			// 落下中
			printxy(x,y ,MOJI_SPACE2,0 )
			printxy(x,y1,MOJI_SNAKE ,sn)
			y=y1
			vwait(3)
		}
	until ch<>MOJI_SPACE
	// 落下したショックで丸まる
	sy(sn)=y
	stime(sn)=stimes
	beep()
	if x=manx and (y+1)=many then {
		// そこが人ならゲームオーバー
		sp_move(PLANE_SNAKE+sn,016,-16):// 落ちたヘビを消す
		return(1):// 落下した先の下に人がいた
	}
	printxy(x,y,MOJI_AT,sn)
	if y=KITIY then return(2):// 基地内に落ちた
	return(0)
endfunc

//****************************************************************

func int wall(x;int,y;int)
// キャラクター判定
int ch
	if y>=KITIY-1 then return(YES):// 基地の中
	y=snakeMoveCheck(x,y)
	x=x0
	ch=scrn(x,y)
 	// 土 / 丸まっているへび / 動いているへび
	if ch=MOJI_TUTI or ch=MOJI_AT or ch=MOJI_SNAKE then return(YES)
	return(NO)
endfunc

//****************************************************************

func int snakeMoveCheck(x;int,y;int)
// へび座標チェック / Check snake coordinate
	if x>=WX 	  then x=0   :y=y+1
	if x<0   	  then x=WX-1:y=y-1
	if y<SNAKEY-1 then y=SNAKEY-1:// 一番上
	if y>=KITIY   then y=KITIY	 :// 一番下（基地の中）
	x0=x:// 2つ目の値を返すためグローバル変数に渡す
	return(y)
endfunc

//****************************************************************

func newsnake(sn;int)
// 新しいへびを出す / Born new snake
int x,y=SNAKEY:// 発生位置
	// へびの発生位置
	repeat
		x=rand2(WX-2)+1
	until scrn(x,y)<>MOJI_SNAKE:// そこには既にへびがいる
	
	// 下が空間の時は落下する
	while scrn(x,y+1)=MOJI_SPACE
		y=y+1
	endwhile
	
	// 座標設定
	sx(sn)=x
	sy(sn)=y
	stime(sn)=0
	
	// 表示
	printxy(x,y,MOJI_SNAKE,sn)
endfunc

//****************************************************************

func inc_snake()
// 経過時間によってへびの数を増やす
	if timer>=0 then timer=timer-1
	if (timer mod 10)=0 then srand2():// ときどき乱数をかき回す
	switch timer
		case 1500
		case 1000
		case  500
		case    0
			newsnake(skazu):// 新しいへびの発生
			skazu=skazu+1
			score(2):// 得点加算
			bell(2)
			if timer=0 then {
				// 警告！！
				bell(2)
				message(localizedString("＞＞　ＤＡＮＧＥＲ　＜＜",">> DANGER <<"),5)
				score(11):// 得点加算:先の+2+11で+13
				hpoint=hpoint*4:// 警告が出た後は得点が４倍になる
				stimes=stimes/2:// 丸まっている時間が半分になる
				warn=1
			} else {
				vwait(6)
			}
			break
	endswitch
endfunc

//****************************************************************

func death()
// へびに食べられた！
int i,x,y
	// 表示が欠けないように座標補正
	x=manx-1
	if x<0   then x=0
	y=many
	if y-3<0 then y=3

	center(MES_Y,localizedString("ギャー　","Gack!! "),YES)
	sp_halt(YES)
	printxys(x,y-2,"**  "):// "◎◎　　"
	printxys(x,y-1,"YY` "):// "▽▽＼　"
	printxys(x,y  ,"  A_")
	printxys(x,y+1,"WW/ "):// "△△／　"
	sp_halt(NO)
	bell(2)
	vwait(27)
	
	// 人が回る
	for i=0 to 4
		printxy(manx,many,MOJI_RMAN,0)
		vwait(8)
		beep()
		printxy(manx,many,MOJI_DMAN,0)
		vwait(8)
		beep()
		printxy(manx,many,MOJI_LMAN,0)
		vwait(8)
		beep()
		printxy(manx,many,MOJI_UMAN,0)
		vwait(8)
		beep()
	next
	//
	center(MES_Y,localizedString("ゴクッ　","Took a gulp"),YES)
	sp_halt(YES)
	printxys(x,y-2,"    "):// "　　　"
	printxys(x,y-1,"**  "):// "◎◎　"
	printxys(x,y  ,"YY`="):// "▽▽＼＝"
	printxys(x,y+1,"WW/ "):// "△△／　"
	sp_halt(NO)
	bell(2)
endfunc

//****************************************************************

func invade()
// 基地を占領された！！
int i,x
	for i=0 to 3
		sp_halt(YES)
		for x=0 to WX-1
			printxy(x,KITIY,MOJI_SPACE,0)
		next
		sp_halt(NO)
		vwait(14)
		sp_halt(YES)
		for x=0 to WX-1
			printxy(x,KITIY,MOJI_SNAKE_BG,0)
		next
		sp_halt(NO)
		beep()
		vwait(14)
	next
	center(MES_Y+1,localizedString("　　基地は占領されました　　","   The base is invaded   "),YES)
endfunc

//****************************************************************
